//AUTHOR: Benjamin Ulmer

#ifndef H_MIC_GREENS
#define H_MIC_GREENS

#include <iostream>
#include <complex>

#include <offload.h>
#include <mkl_dfti.h>

#include "MICBase.h"

#define DKS_SUCCESS 0
#define DKS_ERROR 1

class MICGreensFunction {

private:
  MICBase *m_micbase;

public:

  /* constructor */
  MICGreensFunction(MICBase *base);

  /* destructor */
  ~MICGreensFunction();

  /* compute greens integral analytically */
  int mic_GreensIntegral(void * tmp_ptr_, int I, int J, int K, double hr_m0, double hr_m1, double hr_m2);

  /* perform the actual integration */
  int mic_IntegrationGreensFunction(void * mem_ptr_, void * tmp_ptr_,int I,int J, int K);

  /* Mirror rho-Field */
  int mic_MirrorRhoField(void * mem_ptr_, int I, int J, int K);

  /*multiply complex fields*/
  int mic_MultiplyCompelxFields(void * mem_ptr1_, void * mem_ptr2_, int size);

};

#endif
